import {PostToConnectionCommand} from '@aws-sdk/client-apigatewaymanagementapi'
import type {WsApiConnection, WsApiResponse} from '../types/index.ts'
import {getApiGatewayManagementApiClient} from './getApiGatewayManagementApiClient.ts'

export const sendResponse = async <Response extends WsApiResponse>(
  {endpoint, connectionId}: WsApiConnection,
  response: Response,
): Promise<void> => {
  await getApiGatewayManagementApiClient(endpoint).send(
    new PostToConnectionCommand({
      ConnectionId: connectionId,
      Data: JSON.stringify(response),
    }),
  )
}
